#!/usr/local/bin/perl

use strict;

my $n = 0;
my @v;

while(<>) {
    if( !/^$/ &&
	!/^#/ ) {
	my (@c) = parse_ittext($_);
	if($n > 0) {
	    my ($q) = 0;
	    for(my $i=0;$i<$n;$i++) {
		my ($e) = 0;
		my @m;
		foreach my $j (0..$#c) {
		    $m[$j] = grep(($_ == $c[$j]), @{$v[$i]});
		    $e |= ($m[$j] > 0) ? 1 : 0;
		}
		if($e == 1 && $q == 0) {
		    foreach my $k (0..$#c) {
			if ($m[$k] == 0) {
				push($v[$i], $c[$k]);
			}
		    }
		    $q++;
		}
	    }
	    if($q == 0) {
		$v[$n++] = [ @c ];
	    }
	} else {
	    $v[$n++] = [ @c ];
	}
    }
}

printhecd ($n, @v);

sub printhecd {
    my ($n, @t) = @_;
    foreach my $i (0..$n) {
	my (@y);
	my @x;
	foreach my $k (@{$t[$i]}) {
	    push(@x, $k);
	}
	@x = sort{$a <=> $b} @x;
	foreach my $j (@x) {
	    @y = prehp($j,@y);
	}
	printhecanc(@y);
    }
}

sub printhecanc {
    my ($t, $i) = @_;
    if ($i == 0x1) {
	my @tt = split(/ /, $t);
	foreach my $j (1..$#tt) {
	    pru1($tt[$j], $j, ($#tt-$j));
	}
	$tt[0] =~ /(..)(..)/;
	print "utext[i] = 0x" . $1;
	print "; utext[i+1] = 0x" . $2;
	print ";\n";
    } elsif ($i == 0x2) {
	my @tt = split(/ /, $t);
	foreach my $j (1..$#tt) {
	    pru2($tt[$j], $j, ($#tt-$j), 0);
	}
	$tt[0] =~ /(..)(..)(..)(..)/;
	print "utext[i] = 0x" . $1;
	print "; utext[i+1] = 0x" . $2;
	print "; utext[i+2] = 0x" . $3;
	print "; utext[i+3] = 0x" . $4;
	print "; i+=2;\n";
    } elsif ($i == 0x3) {
	my @tt = split(/ /, $t);
	my $k = 0;
	foreach my $j (1..$#tt) {
	    if($tt[$j] =~ /......../) {
		if($j==1) {
		    $k=1;
		} else {
		    if($k==0) {
			$tt[0] =~ /(..)(..)/;
			print "utext[i] = 0x" . $1;
			print ";  utext[i+1] = 0x" . $2;
			print ";\n/*    } else if(";
			$k=1;
		    }
		}
		pru2($tt[$j], $j, ($#tt-$j), 1);
	    } else {
		if($tt[$j+1] =~ /......../) {
		    pru1($tt[$j], $j, 0);
		} else {
		    pru1($tt[$j], $j, 1);
		}
	    }
	}
	$tt[0] =~ /(..)(..)/;
	print "utext[i] = 0x" . $1;
	print "; utext[i+1] = 0x" . $2;
	print ";*/\n";
    }
}

sub pru1 {
    my ($a, $c, $d) = @_;
    $a =~ /(..)(..)/;
    if ($c == 1) {
	print "    } else if(";
    }
    print "(utext[i] == 0x";
    print $1 . " && utext[i+1] == 0x";
    print $2 . ")";
    if($d == 0) {
	print "){ ";
    } else {
	print " || ";
    }
}

sub pru2 {
    my ($a, $c, $d, $e) = @_;
    $a =~ /(..)(..)(..)(..)/;
    if ($c == 1) {
	if ($e == 1) {
	    print "/*";
	}
	print "    } else if(";
    }
    print "(utext[i] == 0x";
    print $1 . " && utext[i+1] == 0x";
    print $2 . " && utext[i+2] == 0x";
    print $3 . " && utext[i+3] == 0x";
    print $4 . ")";
    if($d == 0) {
	print "){ ";
    } else {
	print " || ";
    }
}
    
sub prehp {
    my ($c, @d) = @_;
    if ( $c > 0x10000 ) {
	my $hi = int(($c - 0x10000) / 0x400) + 0xd800;
	my $lo = ($c - 0x10000) % 0x400 + 0xdc00;
	$d[0] = $d[0] . sprintf("%x%x ", $hi, $lo);
	$d[1] |= 0x2;
    } else {
       	$d[0] .= sprintf("%x ", $c);
	$d[1] |= 0x1;
    }
    return @d;
}

sub parse_ittext {
    my (@c);
    s/U\+([A-F0-9]+)[^A-F0-9]/push(@c,$1)/eg;
    foreach my $j (@c) {
	$j = hex($j);
    }
    return (@c);
}	

